#!/usr/bin/env python
# -*- coding: utf-8 -*-

"""
*****************************************************************************
== == == == == == == == == == == == == == == == == == == == == == == == == ==
BA_Fan Illusion3f4 
== == == == == == == == == == == == == == == == == == == == == == == == == ==
*****************************************************************************
== == == == == == == == == == == == == == == == == == == == == == == == == ==
Future things under consideration.
        --
        logarithmic scaleing for a different scale effect.
        --
        possible rotation for position then transformation of subject
        back to original orientation so flying things stay upright
        --
        automatic export of gif image
        --
Version 3 : add improved auto center.
       improved trim pixels function
       User defined layer name prefixes for detailed layer names.
       usefull when merging frames for gif creation
       added several choices of angle < 1 degree.  
       Due to speed issues with the extreme quantity of layers produced
       when using fractional degree layers or multi rotational runs
       using small degree slices, the script will not save layers
       when the layer quantity exceeds 399.  It will start merging visible
       at 400 and every 200 after.

       added functionality of scaling from small to large, trying for quality
       by making a copy of the normal size base image and for each
       frame and scaling the copy only once.

       Also fixing Rotations so a fraction it will be rounded up to next slice.
       Fix 3 introduces a variable cleanup of the transparent area in the 
       subject layer.  This is an attempt to eliminated the 'layer box'
       that was showing up around the subject layer on 'extreme' layer count runs.
       If this doesn't work, I think about resizing all layers before rotation
 

S2F1 : replace bound center with
       selection of none, crop & autocenter, autocenter no crop, crop image only
S2   : remove bound center, turn manual pivot point into function with x,y input
       tidy up slice table and dialog slice string.
       removed final flip option
== == == == == == == == == == == == == == == == == == == == == == == == == ==
=== === === === === === === === === === === === === ===
=== === === === === === === === === === === === === ===
Here is an explanation of the options and a few general tips
for Fan Illusion v3f4
=== === === === === === === === === === === === === ===
=== === === === === === === === === === === === === ===
This version allows saving layers to help with creation of
circular motions in animated  gifs. 
=== === === === === === === === === === === === === ===
This guide / explanation will start at the top of the script's
dialog box and move line by line to the bottom.
=== === === === === === === === === === === === === ===
=== === === === === === === === === === === === === ===
Cleanup Subject Transparency:
=== === === === === === === === === === === === === ===
Most isolated images, or images which have had any 
transformation operations performed on them have some 
slight feathering in the outer edge pixels.  
This option will perform alpha to selection, select-invert 
and cut from 0 to 500 times (yes 500 is excessive).
If you are creating an excessive amount of layers on a subject, 
try it once without excessive cleanup,  then try it again with 
excessive cleanup. On some, but not all images,  I have noticed 
a very nice effect after using the cleanup with improved color
and sharper definition.   
--- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- ---
If you use the excessive cleanup and you still see some slight 
discoloration in the area at the point where the subject stops rotating, 
double check your subject image at maximum zoom and you will 
probably find some faint pixels which need to be removed manually.  
Some pixels are too strong to remove with the cuts, but  not strong 
enough to be easily seen.  To bring these areas out you can
add a white layer below the subject layer to make any dark areas
stand out, then make the white layer black and check for any
light areas where you should have transparency.
--- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- ---
On the other hand, if you want a less sharp and clear outcome,
you could 'seed' your subject image with very nearly transparent
areas, an easy way would be fill a layer with a color and set the
opacity very low.
=== === === === === === === === === === === === === ===
Number of rotations:
=== === === === === === === === === === === === === ===
You may choose 0.01 to 5.10 rotations.
0.01 will give you a one layer output.
Your selection is rounded up to the next whole slice.
Multiple rotations are not too interesting unless you are adding
some of the other options, like moving pivot point, scaling, 
or cropping pixels from the subject. 
=== === === === === === === === === === === === === ===
Number of Slices:
=== === === === === === === === === === === === === ===
from 2 slices to 5760 slices (per rotation).
Select from a list, which is in #layers @ degrees per slice format.
The smaller the slice angle, the more layers.
To keep the script running as quickly as possible, there is
a maximum number of layers that you may save in the stack.
More on that later in the Keep Layers option explanation.
When you use very small slice angles you will receive a
very smooth looking outcome, but it does take more time to 
process.  While these outcomes are good for backgrounds in
an animated gif, they do not make a very interesting animation,
and the file size of a gif with 1,000 layers or more is quite large.
Layer counts over 399 will be merged to keep the script generating
layers at a rapid pace, and will not be saved as a layer stack, but
as a single outcome layer.  -- It is better this way.
As far as I can tell, most people like the outcomes from lower
slice counts any way, as they have more details as compared
to the smooth look of the extreme layer outcomes.
=== === === === === === === === === === === === === ===
Reverse Slice Direction:
=== === === === === === === === === === === === === ===
The default, No, gives you a clockwise slice rotation.
Yes will give you a counter clockwise slice rotation.
You will often find a striking difference between the 
two outcomes depending on your subject.   I recommend 
trying both directions for every subject.
=== === === === === === === === === === === === === ===
Coordinate or Bounds Option:
=== === === === === === === === === === === === === ===
If you choose, the script will crop the subject and get 
the resulting bounds of the cropped subject selection.
You may choose from  the center of the bounding box
where the subject will rotate around itself, or one of 
the corners of the bounding box (usually more interesting).
--- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- ---
If you would like to select your own pivot point, 
move your mouse to the point you would like to 
have the subject rotated around (the pivot point) 
and look in the bottom left corner of the active image
(just below and to the right of the Quick Mask icon) 
and Gimp shows you the X,Y coordinates of the point your
mouse is pointing to. the enter your selection in the script's 
dialog box with the title 'Enter Pivot Coordinates X,Y'
Be sure that the x and y numbers are delimited with a ',' comma.
Then make certain your option is set to Use Pivot Coordinates,
The x coordinate is on the horizontal (left, right).
The y coordinate is on the vertical (up/down).
The coordinate notation used is formatted as x,y  
(horizontal point, then the vertical point).
Again, the X coordinate is to the left, and the Y is to the right
and make certain there is a comma between them.
The pivot coordinates will be the Center of the 
subject rotation which doesn't mean that it needs to be
the center of the subject or even on the subject, unless
that is what you want.  If it helps, think of yourself
as the pivot point and you hold a rope attached to the
subject and are going to swing the subject around yourself
in a circle.  Experiment and observe and you will be able
to get a feel of the general rotation motion around different
pivots!
=== === === === === === === === === === === === === ===
Motion per Slice
This is a bit harder to see until you have experimented for a while.
The pivot point will move a bit in either or both directions for 
each slice.  It will work with a single rotation or multiple rotations.
=== === === === === === === === === === === === === ===
X center: Motion Per Slice:
=== === === === === === === === === === === === === ===
You may enter decimals or whole numbers.
This option will allow the pivot point on the X axis
to move a selected amount each slice.  A positive number
will move the pivot to the right Horizontally (on  the x axis).
A negative number will move the pivot to  the Left.
=== === === === === === === === === === === === === ===
Y center:  Motion Per Slice:
=== === === === === === === === === === === === === ===
You may enter decimals or whole numbers.
This option will allow the pivot point on the Y axis
to move a selected amount each slice.  A positive number
will move the pivot down vertically (on the Y axis).
A negative number will move the pivot upwards.
=== === === === === === === === === === === === === ===
Scale Direction or None:
=== === === === === === === === === === === === === ===
You may scale the subject on each slice or not.
If you choose not to scale, choose No Scale.
If  No Scale is chosen, it matters not what
is entered in the Scale Maximum or Scale Minimum limits.
--- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- ---
If you chose to scale the subject while slicing it, 
Select Scale Up or Scale Down.
Now enter the scale maximum and minimum amounts.   
100% scale = Original size of the subject
300% scale = 3x the original size
.03% scale =  3% of the original size.
The script will calculate the total number
of pixels in the range from maximum scale to the
minimum scale and divide that range equally in pixels 
throughout the number of slices multiplied by the number 
of rotations.  
You can use the scaling to make an animated gif look as
if it is moving closer or further away from you.
It simulates motion on the Z-axis.
=== === === === === === === === === === === === === ===
Narrow and Shorten options:
=== === === === === === === === === === === === === ===
Scale over rides Narrow & Shorten.
If both are chosen, only the scale will function.
If No Scale is chosen, Narrow and Shorten will function.
Enter the amount in pixels you would like
to crop from the subject at each slice.
You may select bother or either one by itself.
You will receive a warning from the script
if the amount you choose is greater then the width or 
height of the subject.  
It is a one way option (trim only) it will not 
add pixels to the subject.
=== === === === === === === === === === === === === ===
Keep Layers for Gif if < 400
=== === === === === === === === === === === === === ===
To keep the speed of the script high, 
it will merge the layers when 400 count
is reached, and each 200 count thereafter
until the script has completed. 
Again, it is unrealistic to have thousands of
frames in an animated gif outcome.
=== === === === === === === === === === === === === ===
Layer Name Prefix:
=== === === === === === === === === === === === === ===
If you are building a gif, you may want
to use frames from several different 
layer stacks.  Using different prefixes is
a good way to help keep track of what 
goes where.  
Remember to remove your subject layer(s) from 
the stack before saving your .gif and also you can
open a gif in Gimp for editing and re saving.
=== === === === === === === === === === === === === ===
=== === === === === === === === === === === === === ===
And when your outcome appears, if you do not like it, remember
that a <CONTROL>Z will UNDO the script's effect and leave you
back with the subject you ran the script upon.  
Another useful key combo is <CNTRL>D  
When your subject is prepared and ready, <CNTRL>D  duplicates 
the image in Gimp.  I use it to quickly make 6 or 7 copies and then 
start playing with the script using different options, or different 
treatments such as Brightness/Contrast on the subject.
It is nice to be able to compare the outcomes side by side and also 
easy to move layers between images if you see combinations
that you are interested in looking.
=== === === === === === === === === === === === === ===
I hope that you have as much fun
with this script as I do!
=== === === === === === === === === === === === === ===
=== === === === === === === === === === === === === ===
=== === === === === === === === === === === === === ===
== == == == == == == == == == == == == == == == == == == == == == == == == ==
== == == == == == == == == == == == == == == == == == == == == == == == == ==

"""
#!/usr/bin/env python
from gimpfu import *
from math import pi
################################################################################################
### function decode_pivot ######################################################################
################################################################################################
def decode_pivot (pivot):
    global centerx,centery,piv
    piv = pivot.strip() #removes newline chr from string just in case
    piv = piv.lower()
    piv = piv.replace(' ','')
    count_comma = piv.count(',')
    piv = piv.split(',')
    if count_comma < 1: 
        pdb.gimp_message('Pivot Coordinates must be separated with a comma')
        piv[0]= 'error'
        return()
    if count_comma > 1:
        pdb.gimp_message('Pivot Coordinates may only have 1 comma')
        piv[0]= 'error'
        return()
    if len(piv[0]) < 1 or len(piv[1]) < 1:
        pdb.gimp_message('You forgot to enter both pivot Coordinates')
        piv[0]= 'error'
        return()        
    if piv[0]=='x' or piv[1]=='y':
        pdb.gimp_message('You forgot to enter Pivot Coordinates')
        piv[0]= 'error'
        return()
    
    # integer calls will error if not integers so set them.
    # if piv[] is not int, it will throw a base 10  error.
    # i didn't know how to test for that at this time.
    centerx = int(piv[0])
    centery = int(piv[1])
    return centerx,centery
################################################################################################
## end decode_pivot ############################################################################
################################################################################################
## function decode_slices ######################################################################
################################################################################################ 
def decode_slices (slices, rotations):
    global stoploop, sliceangle
    if slices   == 0:
        stoploop =5760*rotations ; sliceangle=.0625
    elif slices == 1:
        stoploop =2880*rotations ; sliceangle= .125
    elif slices == 2:
        stoploop =1440*rotations ; sliceangle= .25
    elif slices == 3:
        stoploop =720*rotations ; sliceangle=  .50
    elif slices == 4:
        stoploop =360*rotations ; sliceangle=  1.0
    elif slices == 5:
        stoploop =240*rotations ; sliceangle=  1.5
    elif slices == 6:
        stoploop =180*rotations ; sliceangle=  2.0
    elif slices == 7:
        stoploop =144*rotations ; sliceangle=  2.5
    elif slices == 8:
        stoploop =120*rotations ; sliceangle=  3.0
    elif slices == 9:
        stoploop = 90*rotations ; sliceangle=  4.0
    elif slices ==10:
        stoploop = 80*rotations ; sliceangle=  4.5
    elif slices ==11:
        stoploop = 72*rotations ; sliceangle=  5.0
    elif slices ==12:
        stoploop = 60*rotations ; sliceangle=  6.0
    elif slices ==13:
        stoploop = 48*rotations ; sliceangle=  7.5
    elif slices ==14:
        stoploop = 45*rotations ; sliceangle=  8.0
    elif slices ==15:
        stoploop = 40*rotations ; sliceangle=  9.0
    elif slices ==16:
        stoploop = 36*rotations ; sliceangle= 10.0
    elif slices ==17:
        stoploop = 30*rotations ; sliceangle= 12.0
    elif slices ==18:
        stoploop = 24*rotations ; sliceangle= 15.0
    elif slices ==19:
        stoploop = 20*rotations ; sliceangle= 18.0
    elif slices ==20:
        stoploop = 18*rotations ; sliceangle= 20.0
    elif slices ==21:
        stoploop = 16*rotations ; sliceangle= 22.5
    elif slices ==22:
        stoploop = 15*rotations ; sliceangle= 24.0
    elif slices ==23:
        stoploop = 12*rotations ; sliceangle= 30.0
    elif slices ==24:
        stoploop = 10*rotations ; sliceangle= 36.0
    elif slices ==25:
        stoploop =  9*rotations ; sliceangle= 40.0
    elif slices ==26:
        stoploop =  8*rotations ; sliceangle= 45.0
    elif slices ==27:
        stoploop =  6*rotations ; sliceangle= 60.0
    elif slices ==28:
        stoploop =  5*rotations ; sliceangle= 72.0
    elif slices ==29:     
        stoploop =  4*rotations ; sliceangle= 90.0
    elif slices ==30:
        stoploop =  3*rotations ; sliceangle=120.0
    else:#slices==31:
        stoploop =  2*rotations ; sliceangle=180.0
#---- if stoploop fractional due to rotations, always round up
    chkstop = stoploop % 1
    if chkstop != 0:
        stoploop = int(stoploop+1)
    
    return stoploop,sliceangle
################################################################################################
## end decode_slices ###########################################################################
################################################################################################ 
 
def BA_Fan_Illusion3f4 (image,drawable,cleanup,rotations,slices,reverse,pivotoption,pivot,
                        xadj,yadj,scaletype,scalemax,scalemin,trimw,trimh,keeplays,layname):

    pdb.gimp_context_push()
    pdb.gimp_image_undo_group_start(image)

#-----##### get subject layer list
    startlayerinventory = image.layers    

#-- set scale context
    pdb.gimp_context_set_interpolation(INTERPOLATION_LANCZOS)

#-- routine to name subject layer for save as png
    oriname = drawable.name  
    if '.' in oriname:
        prefix = oriname.split(".", 1)
        oriname = prefix[0]
    suffix = ",BA_FanIllusion2.png"

#-- declare global for decode functions
    global centerx, centery, sliceangle
#-- init variables
    centerx = centery = sliceangle = 0
#-- init flag
    layermerge = False

    
#-- assign the pivot point coordinates
    if pivotoption   == 0:       
        decode_pivot(pivot)
        if piv[0]=='error':
            pdb.gimp_image_undo_group_end(image)
            pdb.gimp_context_pop()
            return()
        #returns centerx centery
    else:
        pdb.plug_in_autocrop(image, drawable)
        pdb.gimp_image_select_item(image,0,drawable)
        non_empty, x1, y1, x2, y2 = pdb.gimp_selection_bounds(image)
        pdb.gimp_selection_none(image)
        if pivotoption   == 1:   # pivot on center of cropped image
            centerx = .5*(x2-x1) ; centery = .5*(y2-y1)
        elif pivotoption == 2:   # pivot on upperleft of cropped image
            centerx = x1 ; centery = y1
        elif pivotoption == 3:   # pivot on upperight of cropped image
            centerx = x2 ; centery = y1
        elif pivotoption == 4:   # pivot on lowerleft of cropped image
            centerx = x1 ; centery = y2
        elif pivotoption == 5:   # pivot on loweright of cropped image
            centerx = x2 ; centery = y2

#-- decode the loop limit and sliceangle 
    decode_slices (slices, rotations) 
   ##returns stoploop, sliceangle##

#-- set sliceangle for reverse option
    if reverse:
        sliceangle = -sliceangle

#-- test trim width/height
    if image.width <= trimw * stoploop:
        pdb.gimp_message('Total width of trim exceeds subject width')
        return
    if image.height<= trimh * stoploop:
        pdb.gimp_message('Total height of trim exceeds subject height')
        return

### if scale, override trim and calc for operations 
    if scaletype !=0:
#-- scale overrides trimming
        trimw = trimh = 0  #-- scale overrides trim
#-- minimum width height
        minwidth = scalemin * image.width
        minheight= scalemin * image.height
#-- maximum width height
        maxwidth = scalemax * image.width
        maxheight= scalemax * image.height
#-- range to step through 
        widthrange = maxwidth  - minwidth
        heightrange= maxheight - minheight
#-- pixels in steps 
        widthstep = widthrange /stoploop
        heightstep= heightrange/stoploop
    #pdb.gimp_message('w/h steps :'+str(widthstep)+' '+str(heightstep))

#-- setup for process loop
    loopcnt = cutwidth = cutheight = 0
    layprefix=layname.strip(' ')
    finalmerge=[]

#-- cleanup of transparency of subject
    pdb.gimp_image_select_item(image,0,drawable)
    pdb.gimp_selection_invert(image)
    cleanuploopcnt = 0
    while cleanuploopcnt < cleanup:
        pdb.gimp_edit_cut(drawable)
        cleanuploopcnt+=1
    pdb.gimp_selection_none(image) 

###############################
####### start of process loop ##########################################################################
###############################
    while loopcnt < stoploop:
        tmpbug = drawable.copy()
        image.add_layer(tmpbug, 0)
        width = tmpbug.width
        height= tmpbug.height

#--scale layer if selected
        if scaletype != 0:
            if maxwidth-loopcnt*widthstep > minwidth: # calc scale size down to minimum
                #pdb.gimp_message('if mw-lc*ws : '+str(maxwidth-loopcnt*widthstep)+' minw: '+str(minwidth))
                if scaletype == 2:
                    scalewidth = maxwidth - widthstep *loopcnt
                    scaleheight= maxheight- heightstep*loopcnt
                elif scaletype == 1:
                    scalewidth = minwidth + widthstep *loopcnt
                    scaleheight= minheight+ heightstep*loopcnt
                pdb.gimp_layer_scale_full(tmpbug,scalewidth,scaleheight,True,3)
#--if no scale, trim if selected
        elif trimw > 0 or trimh > 0:
            cutwidth+=trimw
            cutheight+=trimh
            pdb.gimp_image_select_item(image,0,tmpbug)
            non_empty, x1, y1, x2, y2 = pdb.gimp_selection_bounds(image)
            pdb.gimp_selection_none(image)             
            pdb.gimp_image_select_rectangle(image,0,x1+cutwidth*.5,y1+cutheight*.5,width-cutwidth, height-cutheight)
            pdb.gimp_selection_invert(image)
            pdb.gimp_edit_cut(tmpbug)
            pdb.gimp_selection_none(image) 

#-- convert slice to radians
        bugangler = loopcnt*sliceangle*(pi/180) #radians per degree

#-- add adjustment to user input coordinates
        centerx = centerx + xadj ##
        centery = centery + yadj ##
      #pdb.gimp_message('bugangler = '+str(bugangler))

#-- rotate layer
        tmpbug = pdb.gimp_item_transform_rotate(tmpbug,bugangler,0,centerx,centery) 

#-- name layer for output stack
        tmpbug.name = layprefix+' '+str(loopcnt+1)+' slice angle:'+str(loopcnt*sliceangle)
        
        if loopcnt > 398 and loopcnt % 200 is 0:  # keep speed up on extreme runs
            layermerge=True
            mergelist=image.layers 
            for i in startlayerinventory:
                mergelist.remove(i) 
                pdb.gimp_item_set_visible(i,False)
            for i in mergelist:
                pdb.gimp_item_set_visible(i,True)
            layer = pdb.gimp_image_merge_visible_layers(image,0)
            layer.name = 'merged '+str(loopcnt)
          
        loopcnt+=1

#############################
####### end of process loop ############################################################################
#############################

    if layermerge or not keeplays :
        layerlist=image.layers
        for i in startlayerinventory:
            layerlist.remove(i)
            pdb.gimp_item_set_visible(i,False)
        for i in layerlist:
            pdb.gimp_item_set_visible(i, True)
        visible = pdb.gimp_image_merge_visible_layers(image,0)  # 0 expand as necessary
        pdb.plug_in_autocrop(image,visible)

    pdb.gimp_image_resize_to_layers(image)
    layerlist=image.layers    
    for layer in layerlist:
        pdb.gimp_layer_resize_to_image_size(layer)

    pdb.gimp_image_undo_group_end(image)
    pdb.gimp_context_pop()

    #return()
register(
    "BA_Fan_Illusion3f4",    
    "Fan Illusion:  Pivot Option overrides Coordinates, Scale Overrides Trim W/H",  
    "Gimp 2.x",
    "animicule@gimpchat.com", 
    "Brian Andersen", 
    "Aug 2017",
    "BA Fan Illusion...", 
    "***", 
   [
      (PF_IMAGE,   "inImage"     ,"Input image                    ",None),
      (PF_DRAWABLE,"inDrawable"  ,"Input drawable                 ",None),
      (PF_SPINNER, "cleanup"     ,"Cleanup Subject Transparency   ",  1,(0,500,1)),
      (PF_SPINNER, "rotations"   ,"Number of Rotations            ",  1,(.01,5.1,.01)),     
      (PF_OPTION,  "slices"      ,"Number of Slices               ", 16,("5760@.0625","2880@.125","1440@.25","720@.50","360@1.0","240@1.5","180@2.0",
                                                                         "144@2.5","120@3.0","90@4.0","80@4.5","72@5.0","60@6.0","48@7.5","45@8.0",
                                                                         "40@9.0","36@10.0","30@12.0","24@15.0","20@18.0","18@20.0","16@22.5","15@24.0",
                                                                         "12@30.0","10@36.0","9@40.0","8@45.0","6@60.0","5@72.0","4@90.0","3@120.0","2@180.0")),
      (PF_BOOL,    "reverse"     ,"Reverse Slice Direction        ",False),
      (PF_OPTION,  "pivotoption" ,"Coordinate or Bounds option    ", 0,("Use Pivot Coordinates", "Crop & Center Bounding Box",
                                                                        "Crop & UpperLeft Bounds", "Crop & UpperRight Bounds",
                                                                        "Crop & LowerLeft Bounds", "Crop & LowerRight Bounds")),
      (PF_STRING,  "pivot"       ,"Enter Pivot Coordinates X,Y    ","x,y"),
      (PF_SPINNER, "xadj"        ,"X center: motion per slice     ", 0,(-50,50,.01)),
      (PF_SPINNER, "yadj"        ,"Y center: motion per slice     ", 0,(-50,50,.01)),
      (PF_OPTION,  "scaletype"   ,"Scale Direction or None        ", 0,("No Scale", "Scale Up", "Scale Down")),
      (PF_SPINNER, "scalemax"    ,"Scale Maximum 3.00 =300% 0=None", 0,( 0,3,.01)),
      (PF_SPINNER, "scalemin"    ,"Scale Minimum Limit .01 = 1%   ",.01,(0,3,.01)),
      (PF_SPINNER, "trimw"       ,"Progressive Narrow W           ", 0,(0,10.00,.01)),
      (PF_SPINNER, "trimh"       ,"Progressive Shorten H          ", 0,(0,10.00,.01)),
      (PF_BOOL,    "keeplays"    ,"Keep Layers for gif if < 400   ",False),
      (PF_STRING,  "layname"     ,"Layer Name Prefix              ","Fan3"),

    ], 
    [],
    BA_Fan_Illusion3f4,
    menu="<Image>/Filters/Animation/Animators",
    )

main()

